Index: branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibCommon/TComWedgelet.cpp
===================================================================
--- branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibCommon/TComWedgelet.cpp	(revision 1203)
+++ branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibCommon/TComWedgelet.cpp	(revision 1209)
@@ -45,5 +45,5 @@
 using namespace std;
 
-#if H_3D_DIM_DMM
+#if NH_3D_DMM
 TComWedgelet::TComWedgelet( UInt uiWidth, UInt uiHeight ) : m_uhXs     ( 0 ),
                                                             m_uhYs     ( 0 ),
@@ -64,9 +64,8 @@
                                                             m_eWedgeRes( rcWedge.m_eWedgeRes ),
                                                             m_bIsCoarse( rcWedge.m_bIsCoarse ),
-                                                            m_uiAng    ( rcWedge.m_uiAng     ),
                                                             m_uiWidth  ( rcWedge.m_uiWidth   ),
                                                             m_uiHeight ( rcWedge.m_uiHeight  ),
-                                                            m_pbPattern( (Bool*)xMalloc( Bool, (m_uiWidth * m_uiHeight) ) )
-                                                            ,m_pbScaledPattern( g_wedgePattern )
+                                                            m_pbPattern( (Bool*)xMalloc( Bool, (m_uiWidth * m_uiHeight) ) ),
+                                                            m_pbScaledPattern( g_wedgePattern )
 {
   ::memcpy( m_pbPattern, rcWedge.m_pbPattern, sizeof(Bool) * (m_uiWidth * m_uiHeight));
@@ -97,33 +96,4 @@
 {
   ::memset( m_pbPattern, 0, (m_uiWidth * m_uiHeight) * sizeof(Bool) );
-}
-
-Void TComWedgelet::findClosestAngle()
-{
-  UInt uiAng=0,uiOptAng=0;
-  UInt uiMinD=MAX_UINT;
-  UInt uiTmpD=0;
-  Int angTable[9]    = {0,    2,    5,   9,  13,  17,  21,  26,  32};
-  
-  UChar uhXs = m_uhXs;
-  UChar uhYs = m_uhYs;
-  UChar uhXe = m_uhXe;
-  UChar uhYe = m_uhYe;
-
-  for(uiAng=2; uiAng<=34; uiAng++)
-  {
-    Int iSign    = (uiAng<VER_IDX && uiAng>HOR_IDX ) ? -1 : 1;
-    Int iVer     = uiAng>17 ? 32 : angTable[(uiAng>10) ? (uiAng-10) : (10-uiAng)];
-    Int iHor     = uiAng<19 ? 32 : angTable[(uiAng>26) ? (uiAng-26) : (26-uiAng)];
-
-    uiTmpD  = abs(iVer*iSign*(uhXs-uhXe) - iHor*(uhYe-uhYs));
-    
-    if( uiTmpD < uiMinD )
-    {
-      uiMinD = uiTmpD;
-      uiOptAng = uiAng;
-    }
-  }
-  m_uiAng = uiOptAng;
 }
 
@@ -205,5 +175,4 @@
   m_eWedgeRes = rcWedge.m_eWedgeRes;
   m_bIsCoarse = rcWedge.m_bIsCoarse;
-  m_uiAng = rcWedge.m_uiAng;
   m_uiWidth  = rcWedge.m_uiWidth;
   m_uiHeight = rcWedge.m_uiHeight;
@@ -295,29 +264,64 @@
 }
 
-Bool* TComWedgelet::getScaledPattern(UInt uiDstSize)
+Bool* TComWedgelet::getPatternScaled( UInt dstSize )
 {
   Bool *pbSrcPat = this->getPattern();
   UInt uiSrcSize = this->getStride();
 
-  Int scale = (g_aucConvertToBit[uiDstSize] - g_aucConvertToBit[uiSrcSize]);
-  assert(scale>=0);
-  for (Int y=0; y<uiDstSize; y++)
-  {
-    for (Int x=0; x<uiDstSize; x++)
-    {
-      Int srcX = x>>scale;
-      Int srcY = y>>scale;
-      m_pbScaledPattern[y*uiDstSize + x] = pbSrcPat[ srcY*uiSrcSize + srcX ];
-    }
-  }
-  return m_pbScaledPattern;
-}
+  if( 16 >= dstSize )
+  {
+    assert( dstSize == uiSrcSize );
+    return pbSrcPat;
+  }
+  else
+  {
+    Int scale = (g_aucConvertToBit[dstSize] - g_aucConvertToBit[uiSrcSize]);
+    assert(scale>=0);
+    for (Int y=0; y<dstSize; y++)
+    {
+      for (Int x=0; x<dstSize; x++)
+      {
+        Int srcX = x>>scale;
+        Int srcY = y>>scale;
+        m_pbScaledPattern[y*dstSize + x] = pbSrcPat[ srcY*uiSrcSize + srcX ];
+      }
+    }
+    return m_pbScaledPattern;
+  }
+}
+
+Void TComWedgelet::getPatternScaledCopy( UInt dstSize, Bool* dstBuf )
+{
+  Bool *pbSrcPat = this->getPattern();
+  UInt uiSrcSize = this->getStride();
+
+  if( 16 >= dstSize )
+  {
+    assert( dstSize == uiSrcSize );
+    memcpy( dstBuf, pbSrcPat, (dstSize*dstSize) );
+  }
+  else
+  {
+    Int scale = (g_aucConvertToBit[dstSize] - g_aucConvertToBit[uiSrcSize]);
+    assert(scale>=0);
+    for (Int y=0; y<dstSize; y++)
+    {
+      for (Int x=0; x<dstSize; x++)
+      {
+        Int srcX = x>>scale;
+        Int srcY = y>>scale;
+        dstBuf[y*dstSize + x] = pbSrcPat[ srcY*uiSrcSize + srcX ];
+      }
+    }
+  }
+}
+
 
 TComWedgeNode::TComWedgeNode()
 {
-  m_uiPatternIdx = DMM_NO_WEDGEINDEX;
+  m_uiPatternIdx = DMM_NO_WEDGE_IDX;
   for( UInt uiPos = 0; uiPos < DMM_NUM_WEDGE_REFINES; uiPos++ )
   {
-    m_uiRefineIdx[uiPos] = DMM_NO_WEDGEINDEX;
+    m_uiRefineIdx[uiPos] = DMM_NO_WEDGE_IDX;
   }
 }
@@ -341,3 +345,3 @@
   m_uiRefineIdx[uiPos] = uiIdx;  
 }
-#endif //H_3D_DIM_DMM
+#endif //NH_3D_DMM
Index: branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibCommon/TComWedgelet.h
===================================================================
--- branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibCommon/TComWedgelet.h	(revision 1203)
+++ branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibCommon/TComWedgelet.h	(revision 1209)
@@ -43,29 +43,27 @@
 #include <vector>
 
-#if H_3D_DIM
-#define DIM_OFFSET     (NUM_INTRA_MODE+1) // offset for DMM and RBC mode numbers (PM: not consistent with spec, but non-overlapping with chroma, see DM_CHROMA_IDX)
-#define DIM_MIN_SIZE                   4  // min. block size for DMM and RBC modes
-#define DIM_MAX_SIZE                  32  // max. block size for DMM and RBC modes
+#if NH_3D_DMM
+#define DMM_OFFSET     (NUM_INTRA_MODE+1) // offset for DMM and RBC mode numbers
+#define DMM_MIN_SIZE                   4  // min. block size for DMM and RBC modes
+#define DMM_MAX_SIZE                  32  // max. block size for DMM and RBC modes
 
-enum DIM_IDX
+enum DmmID
 {
   DMM1_IDX = 0,
   DMM4_IDX = 1,
+  NUM_DMM  = 2,
+  DMM_NO_IDX = MAX_UINT
 };
 
-#define DMM_NUM_TYPE   2
-#define DIM_NUM_TYPE   (DMM_NUM_TYPE)
-#define DIM_NO_IDX     MAX_UINT
+__inline DmmID getDmmType( Int intraMode ) 
+{ 
+    Int dmmType = intraMode-DMM_OFFSET; 
+    return (dmmType >= 0 && dmmType < NUM_DMM) ? (DmmID)dmmType : DMM_NO_IDX; 
+}
+__inline Bool isDmmMode( Int intraMode ) { return ((UInt)getDmmType( intraMode ) < NUM_DMM); }
 
-__inline UInt getDimType  ( Int intraMode ) 
-{ 
-    Int dimType = intraMode-DIM_OFFSET; 
-    return (dimType >= 0 && dimType < DIM_NUM_TYPE) ? (UInt)dimType : DIM_NO_IDX; 
-}
-__inline Bool isDimMode   ( Int intraMode ) { return (getDimType( intraMode ) < DIM_NUM_TYPE); }
-#endif
 
-#if H_3D_DIM_DMM
-#define DMM_NO_WEDGEINDEX       MAX_UINT
+// Wedgelets
+#define DMM_NO_WEDGE_IDX       MAX_UINT
 #define DMM_NUM_WEDGE_REFINES   8
 
@@ -90,5 +88,4 @@
   WedgeResolution m_eWedgeRes;                  // start/end pos resolution
   Bool            m_bIsCoarse; 
-  UInt            m_uiAng;
 
   UInt  m_uiWidth;
@@ -121,14 +118,14 @@
   UChar           getOri     () { return m_uhOri; }
   Bool            getIsCoarse() { return m_bIsCoarse; }
-  UInt            getAng     () { return m_uiAng; }
-  Bool*           getScaledPattern(UInt uiWidth);
 
   Void  generateWedgePatternByRotate(const TComWedgelet &rcWedge, Int rotate);
   Void  setWedgelet( UChar uhXs, UChar uhYs, UChar uhXe, UChar uhYe, UChar uhOri, WedgeResolution eWedgeRes, Bool bIsCoarse = false );
-  Void  findClosestAngle();
 
   Bool  checkNotPlain();
   Bool  checkIdentical( Bool* pbRefPattern );
   Bool  checkInvIdentical( Bool* pbRefPattern );
+
+  Bool* getPatternScaled    ( UInt dstSize );
+  Void  getPatternScaledCopy( UInt dstSize, Bool* dstBuf );
 
 };  // END CLASS DEFINITION TComWedgelet
@@ -162,6 +159,4 @@
 };  // END CLASS DEFINITION TComWedgeRef
 
-// type definition wedgelet reference list
-typedef std::vector<TComWedgeRef> WedgeRefList;
 
 // ====================================================================================================================
@@ -187,14 +182,5 @@
 // type definition wedgelet node list
 typedef std::vector<TComWedgeNode> WedgeNodeList;
-#endif //H_3D_DIM_DMM
+#endif //NH_3D_DMM
 
-
-// ====================================================================================================================
-// Function definition roftoi (mathematically correct rounding of float to int)
-// ====================================================================================================================
-__inline Int roftoi( Double value )
-{
-  (value < -0.5) ? (value -= 0.5) : (value += 0.5);
-  return ( (Int)value );
-}
 #endif // __TCOMWEDGELET__
Index: branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibCommon/TypeDef.h	(revision 1203)
+++ branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibCommon/TypeDef.h	(revision 1209)
@@ -69,5 +69,14 @@
 #if NH_3D
 #define NH_3D_VSO                         1
-#endif
+#define NH_3D_DMM                         1   // Depth modeling modes
+#define NH_3D_SDC                         1   // Segment-wise DC coding for intra and inter
+#define NH_3D_ENC_DEPTH                   1   // Encoder optimizations for depth, incl.
+                                              // HHI_DEPTH_INTRA_SEARCH_RAU_C0160
+                                              // LG_ZEROINTRADEPTHRESI_A0087
+                                              // HHI_DMM4_ENC_I0066
+                                              // H_3D_FAST_DEPTH_INTRA
+#endif
+
+#define TEMP_SDC_CLEANUP                  1   // PM: consider these cleanups for DMM and SDC
 
 #if H_3D
Index: branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibDecoder/TDecCAVLC.cpp
===================================================================
--- branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 1203)
+++ branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 1209)
@@ -3389,9 +3389,4 @@
 #endif
 #if H_3D_INTER_SDC
-Void TDecCavlc::parseDeltaDC( TComDataCU* /*pcCU*/, UInt /*uiAbsPartIdx*/, UInt /*uiDepth*/ )
-{ 
-  assert(0);
-}
-
 Void TDecCavlc::parseSDCFlag    ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
 {
Index: branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibDecoder/TDecCAVLC.h
===================================================================
--- branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibDecoder/TDecCAVLC.h	(revision 1203)
+++ branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibDecoder/TDecCAVLC.h	(revision 1209)
@@ -123,6 +123,8 @@
   Void  parseICFlag         ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
 #endif
+#if NH_3D_DMM || H_3D_DIM_SDC || H_3D_INTER_SDC
+  Void  parseDeltaDC        ( TComDataCU* /*pcCU*/, UInt /*absPartIdx*/, UInt /*depth*/ ) { assert(0); };
+#endif
 #if H_3D_INTER_SDC
-  Void  parseDeltaDC        ( TComDataCU* pcCU, UInt absPartIdx, UInt depth );
   Void  parseSDCFlag        ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
 #endif
Index: branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibDecoder/TDecCu.cpp
===================================================================
--- branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibDecoder/TDecCu.cpp	(revision 1203)
+++ branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibDecoder/TDecCu.cpp	(revision 1209)
@@ -1009,15 +1009,14 @@
 
   //===== get prediction signal =====
-#if H_3D_DIM
-  if( isDimMode( uiLumaPredMode ) )
-  {
-    m_pcPrediction->predIntraLumaDepth( pcCU, uiAbsPartIdx, uiLumaPredMode, piPred, uiStride, uiWidth, uiHeight );
+#if NH_3D_DMM
+  if( bIsLuma && isDmmMode( uiChFinalMode ) )
+  {
+    m_pcPrediction->predIntraLumaDmm( pcCU, uiAbsPartIdx, getDmmType( uiChFinalMode ), piPred, uiStride, uiWidth, uiHeight );
   }
   else
   {
 #endif
-
   m_pcPrediction->predIntraAng( compID,   uiChFinalMode, 0 /* Decoder does not have an original image */, 0, piPred, uiStride, rTu, bAboveAvail, bLeftAvail, bUseFilteredPredictions );
-#if H_3D_DIM
+#if NH_3D_DMM
   }
 #endif
@@ -1040,5 +1039,5 @@
 #endif
 #if H_3D
-  Bool useDltFlag = (isDimMode( uiLumaPredMode ) || uiLumaPredMode == HOR_IDX || uiLumaPredMode == VER_IDX || uiLumaPredMode == DC_IDX) && pcCU->getSlice()->getIsDepth() && pcCU->getSlice()->getPPS()->getDLT()->getUseDLTFlag(pcCU->getSlice()->getLayerIdInVps());
+  Bool useDltFlag = (isDmmMode( uiLumaPredMode ) || uiLumaPredMode == HOR_IDX || uiLumaPredMode == VER_IDX || uiLumaPredMode == DC_IDX) && pcCU->getSlice()->getIsDepth() && pcCU->getSlice()->getPPS()->getDLT()->getUseDLTFlag(pcCU->getSlice()->getLayerIdInVps());
 
   if ( pcCU->getCbf( uiAbsPartIdx, TEXT_LUMA, uiTrDepth ) || useDltFlag )
@@ -1158,8 +1157,4 @@
   }
 }
-#if H_3D_DIM
-      mapDepthModeToIntraDir( uiChromaPredMode );
-#endif
-
 
 Void
@@ -1191,4 +1186,143 @@
 Void TDecCu::xReconIntraSDC( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
 {
+#if TEMP_SDC_CLEANUP // PM: consider this cleanup for DMM and SDC
+  TComYuv* pcRecoYuv  = m_ppcYuvReco[uiDepth];
+  TComYuv* pcPredYuv  = m_ppcYuvReco[uiDepth];
+  TComYuv* pcResiYuv  = m_ppcYuvResi[uiDepth];
+
+  Bool bAboveAvail    = false;
+  Bool bLeftAvail     = false;
+  UInt uiWidth        = pcCU->getWidth ( 0 );
+  UInt uiHeight       = pcCU->getHeight( 0 );
+  UInt uiLumaPredMode = pcCU->getIntraDir( CHANNEL_TYPE_LUMA, uiAbsPartIdx );
+
+  UInt sdcDepth = 0;
+  UInt uiStride;
+  Pel* piReco;
+  Pel* piPred;
+  Pel* piResi;
+
+  UInt uiZOrder;        
+  Pel* piRecIPred;      
+  UInt uiRecIPredStride;
+  
+  Pel apDCPredValues[2];
+  UInt uiNumSegments;
+
+  Bool* pbMask = NULL;
+  UInt uiMaskStride = 0;
+
+#if NH_3D_DMM
+  TComWedgelet* dmm4Segmentation = NULL;
+  if( isDmmMode( uiLumaPredMode ) )
+  {
+    assert( uiWidth == uiHeight  );
+    assert( uiWidth >= DMM_MIN_SIZE && uiWidth <= DMM_MAX_SIZE );
+    assert( !((uiWidth >> pcCU->getSlice()->getSPS()->getQuadtreeTULog2MaxSize()) > 1) );
+
+    uiNumSegments     = 2;
+
+    uiStride          = pcRecoYuv->getStride( COMPONENT_Y );
+    piReco            = pcRecoYuv->getAddr  ( COMPONENT_Y, uiAbsPartIdx );
+    piPred            = pcPredYuv->getAddr  ( COMPONENT_Y, uiAbsPartIdx );
+    piResi            = pcResiYuv->getAddr  ( COMPONENT_Y, uiAbsPartIdx );
+
+    piRecIPred        = pcCU->getPic()->getPicYuvRec()->getAddr  ( COMPONENT_Y, pcCU->getCtuRsAddr(), pcCU->getZorderIdxInCtu() + uiAbsPartIdx );
+    uiRecIPredStride  = pcCU->getPic()->getPicYuvRec()->getStride( COMPONENT_Y );
+
+    //===== init availability pattern =====
+#if !TEMP_SDC_CLEANUP // PM: please migrate together with below "initPattern" and remove macro
+    pcCU->getPattern()->initPattern   ( pcCU, sdcDepth, uiAbsPartIdx );
+    pcCU->getPattern()->initAdiPattern( pcCU, uiAbsPartIdx, sdcDepth, m_pcPrediction->getPredicBuf(), m_pcPrediction->getPredicBufWidth(), m_pcPrediction->getPredicBufHeight(), bAboveAvail, bLeftAvail );
+#endif
+
+    // get partition
+    pbMask       = new Bool[ uiWidth*uiHeight ];
+    uiMaskStride = uiWidth;
+    switch( getDmmType( uiLumaPredMode ) )
+    {
+    case( DMM1_IDX ): { (getWedgeListScaled( uiWidth )->at( pcCU->getDmm1WedgeTabIdx( uiAbsPartIdx ) )).getPatternScaledCopy( uiWidth, pbMask ); } break;
+    case( DMM4_IDX ): { m_pcPrediction->predContourFromTex( pcCU, uiAbsPartIdx, uiWidth, uiHeight, pbMask );                                     } break;
+    default: assert(0);
+    }
+
+    // get predicted partition values
+    Pel predDC1 = 0, predDC2 = 0;
+    m_pcPrediction->predBiSegDCs( pcCU, uiAbsPartIdx, uiWidth, uiHeight, pbMask, uiMaskStride, predDC1, predDC2 );
+
+    // set prediction signal
+    Pel* pDst = piPred;
+    m_pcPrediction->assignBiSegDCs( pDst, uiStride, pbMask, uiMaskStride, predDC1, predDC2 );
+    apDCPredValues[0] = predDC1;
+    apDCPredValues[1] = predDC2;
+  }
+  else // regular HEVC intra modes
+  {
+#endif
+    uiNumSegments = 1;
+
+    UInt numParts = 1;
+    UInt uiSubPartIdx = uiAbsPartIdx;
+
+    if ((uiWidth >> pcCU->getSlice()->getSPS()->getQuadtreeTULog2MaxSize()) > 1)
+    {
+      numParts = uiWidth * uiWidth >> (2 * pcCU->getSlice()->getSPS()->getQuadtreeTULog2MaxSize());
+      sdcDepth = g_aucConvertToBit[uiWidth] + 2 - pcCU->getSlice()->getSPS()->getQuadtreeTULog2MaxSize();
+      uiWidth = uiHeight = (1 << pcCU->getSlice()->getSPS()->getQuadtreeTULog2MaxSize());
+    }
+
+    for ( Int i = 0; i < numParts; i++ )
+    {
+      uiStride    = pcRecoYuv->getStride  ();
+      piReco      = pcRecoYuv->getLumaAddr( uiSubPartIdx );
+      piPred      = pcPredYuv->getLumaAddr( uiSubPartIdx );
+      piResi      = pcResiYuv->getLumaAddr( uiSubPartIdx );
+
+      uiZOrder          = pcCU->getZorderIdxInCU() + uiSubPartIdx;
+      piRecIPred        = pcCU->getPic()->getPicYuvRec()->getLumaAddr( pcCU->getAddr(), uiZOrder );
+      uiRecIPredStride  = pcCU->getPic()->getPicYuvRec()->getStride  ();
+
+      AOF( uiWidth == uiHeight );
+
+      //===== init availability pattern =====
+      pcCU->getPattern()->initPattern   ( pcCU, sdcDepth, uiSubPartIdx );
+      pcCU->getPattern()->initAdiPattern( pcCU, uiSubPartIdx, sdcDepth, m_pcPrediction->getPredicBuf(), m_pcPrediction->getPredicBufWidth(), m_pcPrediction->getPredicBufHeight(), bAboveAvail, bLeftAvail );
+
+      m_pcPrediction->predIntraLumaAng( pcCU->getPattern(), uiLumaPredMode, piPred, uiStride, uiWidth, uiHeight, bAboveAvail, bLeftAvail );
+
+      if ( numParts > 1 )
+      {
+        for( UInt uiY = 0; uiY < uiHeight; uiY++ )
+        {
+          for( UInt uiX = 0; uiX < uiWidth; uiX++ )
+          {
+            piReco        [ uiX ] = ClipY( piPred[ uiX ] );
+            piRecIPred    [ uiX ] = piReco[ uiX ];
+          }
+          piPred     += uiStride;
+          piReco     += uiStride;
+          piRecIPred += uiRecIPredStride;
+        }
+      }
+      uiSubPartIdx += ( (uiWidth * uiWidth) >> 4 );
+    }
+
+    // reset to full block
+    uiWidth  = pcCU->getWidth( 0 );
+    uiHeight = pcCU->getHeight( 0 );
+
+    piReco            = pcRecoYuv->getLumaAddr( uiAbsPartIdx );
+    piPred            = pcPredYuv->getLumaAddr( uiAbsPartIdx );
+    piResi            = pcResiYuv->getLumaAddr( uiAbsPartIdx );
+
+    uiZOrder          = pcCU->getZorderIdxInCU() + uiAbsPartIdx;
+    piRecIPred        = pcCU->getPic()->getPicYuvRec()->getLumaAddr( pcCU->getAddr(), uiZOrder );
+    uiRecIPredStride  = pcCU->getPic()->getPicYuvRec()->getStride  ();
+
+    m_pcPrediction->predConstantSDC( piPred, uiStride, uiWidth, apDCPredValues[0] ); apDCPredValues[1] = 0;
+#if NH_3D_DMM
+  }
+#endif
+#else
   UInt uiWidth        = pcCU->getWidth  ( 0 );
   UInt uiHeight       = pcCU->getHeight ( 0 );
@@ -1242,5 +1376,5 @@
     TComWedgelet* dmm4Segmentation = new TComWedgelet( uiWidth, uiHeight );
     //===== get prediction signal =====
-    if( isDimMode( uiLumaPredMode ) )
+    if( isDmmMode( uiLumaPredMode ) )
     {
       m_pcPrediction->predIntraLumaDepth( pcCU, uiAbsPartIdx, uiLumaPredMode, piPred, uiStride, uiWidth, uiHeight, false, dmm4Segmentation  );
@@ -1292,5 +1426,5 @@
   UInt uiMaskStride = 0;
   
-  if( getDimType( uiLumaPredMode ) == DMM1_IDX )
+  if( getDmmType( uiLumaPredMode ) == DMM1_IDX )
   {
     Int uiTabIdx = pcCU->getDmmWedgeTabIdx(DMM1_IDX, uiAbsPartIdx);
@@ -1304,5 +1438,5 @@
     uiMaskStride = pcCU->isDMM1UpscaleMode( uiWidth ) ? uiWidth : pcWedgelet->getStride();
   }
-  if( getDimType( uiLumaPredMode ) == DMM4_IDX )
+  if( getDmmType( uiLumaPredMode ) == DMM4_IDX )
   {
     uiNumSegments = 2;
@@ -1312,5 +1446,5 @@
   // get DC prediction for each segment
   Pel apDCPredValues[2];
-  if ( getDimType( uiLumaPredMode ) == DMM1_IDX || getDimType( uiLumaPredMode ) == DMM4_IDX )
+  if ( getDmmType( uiLumaPredMode ) == DMM1_IDX || getDmmType( uiLumaPredMode ) == DMM4_IDX )
   {
     apDCPredValues[0] = pcCU->getDmmPredictor( 0 );
@@ -1321,4 +1455,5 @@
     m_pcPrediction->analyzeSegmentsSDC(piPred, uiStride, uiWidth, apDCPredValues, uiNumSegments, pbMask, uiMaskStride, uiLumaPredMode);
   }
+#endif
   
   // reconstruct residual based on mask + DC residuals
@@ -1379,5 +1514,11 @@
     pRecCr += uiStrideC;
   }
+#if NH_3D_DMM
+#if TEMP_SDC_CLEANUP // PM: consider this cleanup for DMM and SDC
+  if( pbMask ) { delete[] pbMask; }
+#else
   dmm4SegmentationOrg->destroy(); delete dmm4SegmentationOrg;
+#endif
+#endif
 }
 #endif
Index: branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibDecoder/TDecEntropy.cpp
===================================================================
--- branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibDecoder/TDecEntropy.cpp	(revision 1203)
+++ branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibDecoder/TDecEntropy.cpp	(revision 1209)
@@ -970,4 +970,5 @@
     assert( pcCU->getCbf(uiAbsPartIdx, TEXT_CHROMA_V) == 1 );
 }
+#endif
 #if H_3D_INTER_SDC
   if( pcCU->getSDCFlag( uiAbsPartIdx ) && !pcCU->isIntra( uiAbsPartIdx) )
@@ -978,24 +979,28 @@
   }
 #endif
-  if( pcCU->getSlice()->getIsDepth() && ( pcCU->getSDCFlag( uiAbsPartIdx ) || pcCU->isIntra( uiAbsPartIdx ) ) )
-  {
-    Int iPartNum = ( pcCU->isIntra( uiAbsPartIdx ) && pcCU->getPartitionSize( uiAbsPartIdx ) == SIZE_NxN ) ? 4 : 1;
-    UInt uiPartOffset = ( pcCU->getPic()->getNumPartInCU() >> ( pcCU->getDepth( uiAbsPartIdx ) << 1 ) ) >> 2;
-  
-    if( !pcCU->getSDCFlag( uiAbsPartIdx ) )
-    {
-      for( Int iPart = 0; iPart < iPartNum; iPart++ )
-      {
-        if( getDimType( pcCU->getLumaIntraDir( uiAbsPartIdx + uiPartOffset*iPart ) ) < DIM_NUM_TYPE ) 
-        {
-          m_pcEntropyDecoderIf->parseDeltaDC( pcCU, uiAbsPartIdx + uiPartOffset*iPart, uiDepth + ( pcCU->getPartitionSize( uiAbsPartIdx ) == SIZE_NxN ) );
-        }
-      }
-    }
-    else
+#if NH_3D
+  if( pcCU->getSlice()->getIsDepth() )
+  {
+#if H_3D_DIM_SDC || H_3D_INTER_SDC
+    if( pcCU->getSDCFlag( uiAbsPartIdx ) )
     {
       m_pcEntropyDecoderIf->parseDeltaDC( pcCU, uiAbsPartIdx, uiDepth );
       return;
     }
+#endif
+#if NH_3D_DMM
+    if( pcCU->isIntra( uiAbsPartIdx ) )
+    {
+      Int iPartNum = ( pcCU->isIntra( uiAbsPartIdx ) && pcCU->getPartitionSize( uiAbsPartIdx ) == SIZE_NxN ) ? 4 : 1;
+      UInt uiPartOffset = ( pcCU->getPic()->getNumPartitionsInCtu() >> ( pcCU->getDepth( uiAbsPartIdx ) << 1 ) ) >> 2;
+      for( Int iPart = 0; iPart < iPartNum; iPart++ )
+      {
+        if( isDmmMode( pcCU->getIntraDir( CHANNEL_TYPE_LUMA, uiAbsPartIdx + uiPartOffset*iPart ) ) )
+        {
+          m_pcEntropyDecoderIf->parseDeltaDC( pcCU, uiAbsPartIdx + uiPartOffset*iPart, uiDepth + ( pcCU->getPartitionSize( uiAbsPartIdx ) == SIZE_NxN ) );
+        }
+      }
+    }
+#endif
   }
 #endif
Index: branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibDecoder/TDecEntropy.h
===================================================================
--- branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibDecoder/TDecEntropy.h	(revision 1203)
+++ branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibDecoder/TDecEntropy.h	(revision 1209)
@@ -91,6 +91,8 @@
   virtual Void parseICFlag        ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth ) = 0;
 #endif
+#if NH_3D_DMM || H_3D_DIM_SDC || H_3D_INTER_SDC
+  virtual Void  parseDeltaDC      ( TComDataCU* pcCU, UInt absPartIdx, UInt depth ) = 0;
+#endif
 #if H_3D_INTER_SDC
-  virtual Void parseDeltaDC       ( TComDataCU* pcCU, UInt absPartIdx, UInt depth ) = 0;
   virtual Void parseSDCFlag       ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth ) = 0;
 #endif
@@ -180,4 +182,5 @@
   Void decodeICFlag            ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
 #endif
+
 #if H_3D_INTER_SDC
   Void decodeSDCFlag           ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
